
typedef unsigned long ul;
typedef unsigned int ui;
typedef unsigned char uc;

char get_g (int m);
char get_d (int m);

bool hay (const char *id); //determine si le calcul a déja été fait
//void AddResult (const char *id, GEN pmin, GEN val); //ajoute le resultat dans results.txt

struct Arete
{
	int e; //etat d'arrivée
	char c; //lettre
	
	void init ();
};

struct Etat
{
	Arete *a; //liste d'aretes
	ui n; //nombre d'aretes
	bool final; //état final ?
	
	void init ();
	void New (ui n2); //alloue la liste des aretes
	void New (Etat e); //copie un état en allouant la mémoire
	void Del (); //libere la liste des aretes
};

struct Automate
{
	Etat *e; //liste d'etats
	ui n; //nombre d'etats
	int ef; //état final (s'il n'y en a qu'un)
	
	void New (ui n2); //alloue la liste des etats
	void Del (); //libere la liste des etats
	//Automate determinise (char *a, ui n); //donne l'automate déterminisé de l'automate d'alphabet a
	//void Save_FSM (const char *file); //enregistre au format FSM
	void Save_FSM (); //enregistre au format FSM
	void Save_FSM (bool *s); //enregistre au format FSM en ne gardant qu'une partie des sommets
	void Save_FSM2 ();
	void Save_FSM3 ();
	void Save_FSM4 ();
	//void Load_FSM (const char *file);
	void Load_FSM ();
	void Load_FSM (int ar); //automate d'arité ar
	void disp_matrice (bool nob);
	
	bool *Emonde (); //supprimme les états qui ne servent à rien (i.e. qui n'aboutissent pas à un état final)
	bool *Emonde0 (); //supprimme les états qui ne servent à rien en interdisant les arêtes 0 (i.e. qui n'aboutissent pas à un état final)
	void Parcours (bool *s, int i); //utilisé par Emonde
	
	bool Rec (int *m, int l); //détermine si le mot est reconnu ou non par l'automate
	
	//GEN get_PARI (); //retourne la matrice au format de Pari
};

//
